<?php
if (isset($_GET['debug'])) {
	$debug = $_GET['debug'];
}
else {
	$debug = 'false';
}

echo "<html><head>\n";
echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
echo "<title>SpoFo Registration Report</title>\n";

echo '<link rel="stylesheet" type="text/css" href="report.css">' . "\n";

echo "</head><body>";

// http://private.xmlteam.com/alank14/spofo/report.php

// Function to get all the dates in given range
function getDatesFromRange($start, $end, $format = 'Y-m-d') {
      
    // Declare an empty array
    $array = array();
      
    // Variable that store the date interval
    // of period 1 day
    $interval = new DateInterval('P1D');
  
    $realEnd = new DateTime($end);
    $realEnd->add($interval);
  
    $period = new DatePeriod(new DateTime($start), $interval, $realEnd);
  
    // Use loop to store date into array
    foreach($period as $date) {                 
        $array[] = $date->format($format); 
    }
  
    // Return the array elements
    return $array;
}
  
// Function call with passing the start date and end date
date_default_timezone_set('America/New_York');

$unshipped_us = 0;
$unshipped_ca = 0;

	# site db vars
	$site_sqlhost = 'xmlt-production.cluster-cptz51gn1569.us-east-1.rds.amazonaws.com';
	$site_sqluser = 'admin';
	$site_sqlpass = 'z4Sr9P0ytd7mXA>V6!pI';
	$site_sqldb = 'sportsforecaster_site';

	$site_sql = "SELECT
		subscriptions.id
		, subscriptions.user_id
		, subscriptions.stripe_price
		, subscriptions.created_at
		, subscription_fulfillments.fulfillment_date
		, subscription_fulfillments.carrier_info
		, subscription_fulfillments.carrier_key
	FROM
		subscriptions
	LEFT JOIN subscription_fulfillments
		ON subscription_fulfillments.subscription_id = subscriptions.user_id
	WHERE
		(subscriptions.stripe_status = 'active'
		OR subscriptions.stripe_status = 'incomplete')
		AND (subscriptions.stripe_price = 'price_1JIdD5LDI6enxzZNkTFbUpK9' OR subscriptions.stripe_price = 'price_1JIdD5LDI6enxzZNGMSbpUQn')
		";

	# db vars
	$sqlhost = 'gamesv5-prod.cluster-cptz51gn1569.us-east-1.rds.amazonaws.com';
	$sqluser = 'admin';
	$sqlpass = 'SeSLQ6!zRq';
	$sqldb = 'gamesv5';

	function dbOpen ($sqlhost, $sqluser, $sqlpass, $sqldb) {
		$conn = mysqli_connect($sqlhost, $sqluser, $sqlpass, $sqldb);
		if (!$conn) {
			die("Could not connect to mysql");
		}
		mysqli_query($conn,"SET NAMES 'utf8'");

		return $conn;
	}

	function dbClose($conn) {
		mysqli_close($conn);
	}


	$site_conn = dbOpen($site_sqlhost, $site_sqluser, $site_sqlpass, $site_sqldb);

	$site_result = mysqli_query($site_conn,$site_sql) or die(mysqli_error($site_conn));

	$site_user = array();
	while($row = mysqli_fetch_array($site_result)) {
		if ($row['stripe_price'] == 'price_1JIdD5LDI6enxzZNkTFbUpK9') {
			$the_product = 'US-Year';
		}
		else if ($row['stripe_price'] == 'price_1JIdD5LDI6enxzZNGMSbpUQn') {
			$the_product = 'CA-Year';
		}
		else if ($row['stripe_price'] == 'price_1JO8rJLDI6enxzZNw1oqmbH3') {
			$the_product = 'US-Month';
		}
		else {
			$the_product = 'CA-Month';
		}
		
		$site_user[$row['user_id']]['product'] = $the_product;
		$site_user[$row['user_id']]['creation_date'] = $row['created_at'];
		$site_user[$row['user_id']]['carrier_info'] = $row['carrier_info'];
		$site_user[$row['user_id']]['fulfillment_date'] = $row['fulfillment_date'];
		$site_user[$row['user_id']]['carrier_key'] = $row['carrier_key'];
	}

	dbClose($conn);









	$sql = "SELECT
		ur_user_registrations.id AS user_id
		, ur_user_registrations.email
		, ur_user_registrations.timezone
		, ur_user_registrations.first_name
		, ur_user_registrations.last_name
		, ur_user_registrations.birthday
		, ur_user_registrations.address
		, ur_user_registrations.city
		, ur_user_registrations.state
		, ur_user_registrations.postal_code
		, ur_user_registrations.country
		, ur_user_registrations.verified
		, ur_user_registrations.created_at
		, ad_world_states.name AS state_name
		, ad_world_countries.name AS country_name
	FROM
		ur_user_registrations
	LEFT JOIN ad_world_states
		ON ur_user_registrations.state = ad_world_states.id
	LEFT JOIN ad_world_countries
		ON ur_user_registrations.country = ad_world_countries.id
	WHERE
		ur_user_registrations.terms = '1'
		AND ur_user_registrations.email != 'ronit@xmlteam.com'
		AND ur_user_registrations.email NOT LIKE 'karben+%@gmail.com'
	ORDER BY
		ur_user_registrations.created_at desc
	;";




	if ($debug == 'true') {
		echo '<pre>';
		echo $sql;
		echo '</pre>';
	}
	
$conn = dbOpen($sqlhost, $sqluser, $sqlpass, $sqldb);

$result = mysqli_query($conn,$sql) or die(mysqli_error($conn));
$num_results = $result->num_rows;
$usersByDateArray = array();

// echo '<div style="text-align:center;"><a href="http://www.coolfundraisingideas.net/" alt="Fundraising Thermometer"><img border="0" src="http://www.coolfundraisingideas.net/thermometer/thermometer.php?currency=none&goal=7000&raised=1&color=red&size=large"></a><p style="font-size:.8em; color:#999">Provided by <a href="http://www.coolfundraisingideas.net/" rel="nofollow" style="display:block; text-decoration:none; font-size:.8em; color:#999">CoolFundraisingIdeas.net</a></p></div>';

$tableText = '';

$tableText .= "<table cellspacing='0' cellpadding='6'>";
$tableText .= "<tr bgcolor='#cccccc' valign='top'>";
$tableText .= '<th align="left">Rank</th>';
$tableText .= '<th align="left">First</th>';
$tableText .= '<th align="left">Last</th>';
$tableText .= '<th align="left">Email <span style="color:red;font-size:12px;">(unverified)</span><br>User ID - Birthday</th>';
$tableText .= '<th align="left">Address</th>';
$tableText .= '<th align="left">Reg. Date</th>';
$tableText .= '<th align="left">Shipped?</th>';
$tableText .= '<th align="left">Paid Date</th>';
$tableText .= '<th align="left">Pro Pack</th>';
$tableText .= "</tr>";
$currentMonth = "";
$i = 0;

$canCount = 0;
$usaCount = 0;
$blankCount = 0;

$paidCanCount = 0;
$paidUsaCount = 0;

while($row = mysqli_fetch_array($result)) {
	$i++;
	$signuprank = $num_results - $i + 1;
	$creationMonth = substr($row['created_at'],0,7);



	// todo: fix me
	if (array_key_exists($row['user_id'],$site_user)) {
		$oldUtcTime = $site_user[$row['user_id']]["creation_date"];
		$nyc_date = new DateTime($oldUtcTime, new DateTimeZone('UTC'));
		$nyc_date->setTimeZone(new DateTimeZone('America/New_York'));
		$nycPaidDate = $nyc_date->format('Y-m-d H:i:s');

		$paidTableText = "<td>$nycPaidDate</td>";
		
		$curPaidDate = substr($nycPaidDate,0,10);
		if (array_key_exists($curPaidDate, $usersByDateArray)) {
			$usersByDateArray[$curPaidDate]['paidCount'] = $usersByDateArray[$curPaidDate]['paidCount'] + 1;
		}
		else {
			$usersByDateArray[$curPaidDate]['regCount'] = 0;
			$usersByDateArray[$curPaidDate]['paidCount'] = 1;
		}
		
		
		$paidTableText .= "<td>" . $site_user[$row['user_id']]["product"] . "</td>";
		if ($site_user[$row['user_id']]["product"] == 'CA-Year') {
			$paidCanCount++;
		}
		else if ($site_user[$row['user_id']]["product"] == 'US-Year') {
			$paidUsaCount++;
		}
		
	}
	else {
		$paidTableText = "<td></td>";
		$paidTableText .= "<td></td>";
	}
	
	$tableText .= "<tr valign='top'>";
	$tableText .= "<td>" . $signuprank . "</td>";
	
	
	$tableText .= "<td>" . $row['first_name'] . "</td>";
	$tableText .= "<td>" . $row['last_name'] . "</td>";
	$tableText .= "<td><span style='";
	if ($row['verified'] == '0') {
		$tableText .= "color: red;";
	}
	$tableText .= "'>" . $row['email'];
	$tableText .= "</span>";
	if ($debug == 'true') {
		$tableText .= "</td><td>";
	}
	else {
		$tableText .= "<br/>";
	}
	

	$currentDate = date('Ymd'); 
	$startDate = date('Ymd', strtotime('-30 days'));
	$endDate = $currentDate;
	$analyticsURL = 'https://analytics.google.com/analytics/web/#/report/visitors-user-activity/a49818302w81649804p249622417/_u.date00=' . $startDate . '&_u.date01=' . $endDate . '&_r.userId=' . $row['user_id'] . '&_r.userListReportStates=%3F_u.date00=' . $currentDate . '%2526_u.date01=' . $currentDate . '&_r.userListReportId=visitors-user-id/';
	$tableText .= "<a target='_blank' href='$analyticsURL'>" . $row['user_id'] . "</a>";
	if ($row['birthday'] != '') {
		$tableText .= " - " . $row['birthday'];
	}

	$tableText .= "</td>";

	$tableText .= "<td>";
	$tableText .= $row['address'];
	$tableText .= '<br/>';
	$tableText .= $row['city'];
	if ($row['city'] != '') {
		$tableText .= ', ';
	}
	if ($row['state_name'] != '') {
		$thestatename = $row['state_name'];
		$stateparse = json_decode($thestatename);
		$state_en = $stateparse->{'en_US'};
		$tableText .= $state_en;
		$tableText .= " ";
	}
	$tableText .= $row['postal_code'];
	$tableText .= "<br/>";
	if ($row['country_name'] != '') {
		$thecountryname = $row['country_name'];
		$countryparse = json_decode($thecountryname);
		$country_en = $countryparse->{'en_US'};
		$tableText .= $country_en;
		if ($country_en == 'United States') {
			$usaCount++;
		}
		else if ($country_en == 'Canada') {
			$caCount++;
		}
	}
	else {
		$blankCount++;
	}
	$tableText .= "</td>";





	$oldUtcTime = $row['created_at'];
	$nyc_date = new DateTime($oldUtcTime, new DateTimeZone('UTC'));
	$nyc_date->setTimeZone(new DateTimeZone('America/New_York'));
	$nycRegDate = $nyc_date->format('Y-m-d H:i:s');

	$tableText .= "<td>$nycRegDate</td>";
	
	$curRegDate = substr($nycRegDate,0,10);
	if (array_key_exists($curRegDate, $usersByDateArray)) {
		$usersByDateArray[$curRegDate]['regCount'] = $usersByDateArray[$curRegDate]['regCount'] + 1;
	}
	else {
		$usersByDateArray[$curRegDate]['regCount'] = 1;
		$usersByDateArray[$curRegDate]['paidCount'] = 0;
	}
		
	$tableText .= "<td>";
	if ($country_en == 'Canada') {
		if (($site_user[$row['user_id']]["product"] == 'CA-Year') && ($site_user[$row['user_id']]["carrier_info"] != 'linkscorp.ca')) {
			$unshipped_ca++;
			$tableText .= "<span style='background:pink;'>Unshipped CA</span>";
		}
		else if ($site_user[$row['user_id']]["carrier_info"] == 'linkscorp.ca') {
		$tableText .= "<input type='button' onClick='window.alert(\"Linkscorp.ca Shipment Request Date: " . $site_user[$row['user_id']]["fulfillment_date"] . "\");' value='LC: " . $site_user[$row['user_id']]["carrier_key"] . "'/>";
		}
	}
	if ($country_en == 'United States') {
		if (($site_user[$row['user_id']]["product"] == 'US-Year') && ($site_user[$row['user_id']]["carrier_info"] != 'shipbob.com')) {
			$unshipped_us++;
			$tableText .= "<span style='background:pink;'>Unshipped US</span>";
		}
		else if ($site_user[$row['user_id']]["carrier_info"] == 'shipbob.com') {
			$tableText .= "<input type='button' onClick='window.alert(\"ShipBob.com Shipment Request Date: " . $site_user[$row['user_id']]["fulfillment_date"] . "\");' value='SB: " . $site_user[$row['user_id']]["carrier_key"] . "'/>";
		}
	}
	$tableText .= "</td>";
	
	
	$tableText .= $paidTableText;
	
	$tableText .= "</tr>";
}
$tableText .= "</table>";

dbClose($conn);

$someAddressCount = $caCount + $usaCount;
$totalPaidCount = $paidUsaCount + $paidCanCount;

$allTurnedPro = $totalPaidCount / $i;
$allTurnedPro = sprintf("%.1f%%", $allTurnedPro * 100);
	
$caTurnedPro = $paidCanCount / $caCount;
$caTurnedPro = sprintf("%.1f%%", $caTurnedPro * 100);

$usTurnedPro = $paidUsaCount / $usaCount;
$usTurnedPro = sprintf("%.1f%%", $usTurnedPro * 100);

$proThatIsUS = $paidUsaCount / $totalPaidCount;
$proThatIsUS = sprintf("%.1f%%", $proThatIsUS * 100);

$proThatIsCA = $paidCanCount / $totalPaidCount;
$proThatIsCA = sprintf("%.1f%%", $proThatIsCA * 100);

$uscaTurnedPro = $totalPaidCount / $someAddressCount; 
$uscaTurnedPro = sprintf("%.1f%%", $uscaTurnedPro * 100);

$unshipped_total = $unshipped_ca + $unshipped_us;
?>
<style>
table.summary_table td {
	font-size:12px;
}
tr.summary_header td {
	font-weight: bold;
}
</style>
	<?php
	
	// Summary at the Top
	
	echo "<table><tr valign='top'><td>";

	echo "<h1>SpoFo Registration Report</h1>\n";
	echo "<p>(all times Eastern)</p>\n";


echo '<table class="summary_table" cellpadding="4">';
echo '<tr class="summary_header"><td></td><td align="right">Registered</td><td align="right">Paid</td><td>% turned pro</td><td>% of all pros</td><td>Unshipped</td></tr>';
echo '<tr bgcolor="#cccccc"><td>TOTAL:</td><td align="right">' . $i . '</td><td align="right" bgcolor="#51F1A3"><b>' . $totalPaidCount . '</b></td><td align="right">' . $allTurnedPro . '</td><td align="right"></td><td align="left">' . $unshipped_total . '</td></tr>';
echo '<tr><td>Canada:</td><td align="right">' . $caCount . '</td><td align="right">' . $paidCanCount . '</td><td align="right">' . $caTurnedPro . '</td><td align="right">' . $proThatIsCA . '</td><td align="left"><a href="shipping-ca.php">' . $unshipped_ca . ' unshipped CA</a></td></tr>';
echo '<tr><td>USA:</td><td align="right">' . $usaCount . '</td><td align="right">' . $paidUsaCount . '</td><td align="right">' . $usTurnedPro . '</td><td align="right">' . $proThatIsUS . '</td><td align="left"><a href="shipping-us.php">' . $unshipped_us . ' unshipped US</a></td></tr>';
echo '<tr bgcolor="#eeeeee"><td nowrap>CA or US Address:</td><td align="right">' . $someAddressCount . '</td><td align="right">' . $totalPaidCount . '</td><td align="right">' . $uscaTurnedPro . '</td></td><td>&nbsp;</td><td>&nbsp;</td></tr>';
echo '<tr><td>NO ADDRESS:</td><td align="right">' . $blankCount . '</td></tr>';
echo '</table>';

echo "</td><td>";


$currentDate = date('Y-m-d', time());
$dateArray = getDatesFromRange('2022-08-02', $currentDate);
$firstDataString = 'TRUE';
foreach ($dateArray AS $iteratingDate) {
    if ($firstDataString == 'TRUE') {
  	  $theDataString = "";
  	  $firstDataString = 'FALSE';
    }
    else {
  	  $theDataString .= ",";
    }
	
	$theDataString .= "['" . substr($iteratingDate,5,5) . "',";
	if (array_key_exists($iteratingDate,$usersByDateArray)) {
		$theDataString .= $usersByDateArray[$iteratingDate]['regCount'];
		$theDataString .= ",";
		$theDataString .= $usersByDateArray[$iteratingDate]['paidCount'];
	}
	else {
		$theDataString .= "'0','0'";
	}
	$theDataString .= "]";
		
}

$dateArray2021 = getDatesFromRange('2021-08-22', '2021-11-01');
$firstDataString = 'TRUE';
foreach ($dateArray2021 AS $iteratingDate) {
    if ($firstDataString == 'TRUE') {
  	  $theDataString2021 = "";
  	  $firstDataString = 'FALSE';
    }
    else {
  	  $theDataString2021 .= ",";
    }
	
	$theDataString2021 .= "['" . substr($iteratingDate,5,5) . "',";
	if (array_key_exists($iteratingDate,$usersByDateArray)) {
		$theDataString2021 .= $usersByDateArray[$iteratingDate]['regCount'];
		$theDataString2021 .= ",";
		$theDataString2021 .= $usersByDateArray[$iteratingDate]['paidCount'];
	}
	else {
		$theDataString2021 .= "'0','0'";
	}
	$theDataString2021 .= "]";
		
}
?>
  <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
  <script type="text/javascript">
    google.charts.load('current', {'packages':['corechart']});
    google.charts.setOnLoadCallback(drawChart);

    function drawChart() {
      var data = google.visualization.arrayToDataTable([
        ['Day', 'Free Registrations','Paid Subscriptions'],
		  <?php echo $theDataString; ?>
      ]);

      var options = {
        title: '2022 Daily Registrations and Subscriptions',
      //  curveType: 'function',
        legend: { position: 'bottom' },
		series: {
			0: { color: 'blue' },
			1: { color: 'green' }
		}
      };

      var chart = new google.visualization.LineChart(document.getElementById('curve_chart'));

      chart.draw(data, options);
    }
  </script>


  <div id="curve_chart" style="width: 500px; height: 250px"></div>
<?php


echo "</td>";
echo "<td>";

?>
  <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
  <script type="text/javascript">
    google.charts.load('current', {'packages':['corechart']});
    google.charts.setOnLoadCallback(drawChart);

    function drawChart() {
      var data = google.visualization.arrayToDataTable([
        ['Day', 'Free Registrations','Paid Subscriptions'],
		  <?php echo $theDataString2021; ?>
      ]);

      var options = {
        title: '2021 Daily Registrations and Subscriptions',
      //  curveType: 'function',
        legend: { position: 'bottom' },
		series: {
			0: { color: 'blue' },
			1: { color: 'green' }
		}
      };

      var chart = new google.visualization.LineChart(document.getElementById('curve_chart2'));

      chart.draw(data, options);
    }
  </script>


  <div id="curve_chart2" style="width: 500px; height: 250px"></div>
<?php


echo "</td>";

echo "</tr></table>";
echo '<br/>';


echo $tableText;


?>

